<form autocomplete="off">

    {{log "active-effect-config.hbs" this}}

    <!-- Effect Header -->
    <header class="sheet-header">
        <img class="effect-icon" src="{{ data.img }}" data-edit="icon">
        <h1 class="effect-title">
            <input name="name" type="text" value="{{data.name}}" placeholder="{{ localize 'Name' }}" />
        </h1>
    </header>

    <!-- Effect Configuration Tabs -->
    <nav class="sheet-tabs tabs" aria-role="{{localize 'SHEETS.FormNavLabel'}}">
        <a class="item" data-tab="details"><i class="fas fa-book"></i> {{localize "EFFECT.TabDetails"}}</a>
        <a class="item" data-tab="duration"><i class="fas fa-clock"></i> {{localize "EFFECT.TabDuration"}}</a>
        <a class="item" data-tab="effects"><i class="fas fa-cogs"></i> {{localize "EFFECT.TabEffects"}}</a>
    </nav>

    <!-- Details Tab -->
    <section class="tab" data-tab="details">
        <div class="form-group">
            <label>{{ localize "EFFECT.IconTint" }}</label>
            <div class="form-fields">
                <color-picker name="tint" value="{{data.tint}}"></color-picker>
            </div>
        </div>

        <div class="form-group stacked">
            <label>{{ localize "EFFECT.Description" }}</label>
            {{editor descriptionHTML target="description" button=false editable=editable  collaborate=false}}
        </div>

        <div class="form-group">
            <label>{{ localize "EFFECT.Disabled" }}</label>
            <input type="checkbox" name="disabled" {{ checked data.disabled }} />
        </div>

        {{#if isActorEffect}}
            <div class="form-group">
                <label>{{ localize "EFFECT.Origin" }}</label>
                <div class="form-fields">
                    <input type="text" name="origin" value="{{ data.origin }}" disabled />
                </div>
            </div>
        {{/if}}

        {{#if isItemEffect}}
            <div class="form-group">
                <label>{{ labels.transfer.name }}</label>
                <div class="form-fields">
                    <input type="checkbox" name="transfer" {{checked data.transfer}} />
                </div>
                <p class="hint">{{ labels.transfer.hint }}</p>
            </div>
        {{/if}}
    </section>

    <!-- Duration Tab -->
    <section class="tab" data-tab="duration">
        <div class="form-group">
            <label>{{ localize "EFFECT.DurationSecs" }}</label>
            <div class="form-fields">
                <input type="number" name="duration.seconds" value="{{ data.duration.seconds }}" />
            </div>
        </div>
        <div class="form-group">
            <label>{{ localize "EFFECT.StartTime" }}</label>
            <div class="form-fields">
                <input type="number" name="duration.startTime" value="{{ data.duration.startTime }}" />
            </div>
        </div>
        <hr />
        <div class="form-group">
            <label>{{ localize "EFFECT.DurationTurns" }}</label>
            <div class="form-fields">
                <label>{{ localize "COMBAT.Rounds" }}</label>
                <input type="number" name="duration.rounds" value="{{ data.duration.rounds }}" />
                <label>{{ localize "COMBAT.Turns" }}</label>
                <input type="number" name="duration.turns" value="{{ data.duration.turns }}" />
            </div>
        </div>
        <div class="form-group">
            <label>{{ localize "EFFECT.Combat" }}</label>
            <div class="form-fields">
                <input type="text" name="duration.combat" value="{{ data.duration.combat }}" disabled />
            </div>
        </div>

        <div class="form-group">
            <label>{{ localize "EFFECT.StartTurns" }}</label>
            <div class="form-fields">
                <label>{{ localize "COMBAT.Round" }}</label>
                <input type="number" name="duration.startRound" value="{{ data.duration.startRound }}" />
                <label>{{ localize "COMBAT.Turn" }}</label>
                <input type="number" name="duration.startTurn" value="{{ data.duration.startTurn }}" />
            </div>
        </div>
    </section>

    <!-- Effects Tab -->
    <section class="tab" data-tab="effects">
        <header class="effect-change effects-header flexrow">
            <div class="key" style="flex: 1;">{{ localize "EFFECT.ChangeKey" }}</div>
            <div class="mode">{{ localize "EFFECT.ChangeMode" }}</div>
            <div class="value">{{ localize "EFFECT.ChangeValue" }}</div>
            <div class="effect-controls">
                <a class="effect-control" data-action="add"><i class="far fa-plus-square"></i></a>
            </div>
        </header>
        <ol class="changes-list">
            {{#each data.changes as |change i|}}
                <li class="effect-change flexrow" data-index="{{i}}">

                    {{!-- effect key/data point --}}
                    <div class="key">
                        <input class="effect-change-key" list="predefinedOptions_{{@root.effect.uuid}}" type="text" name="changes.{{i}}.key"
                            value="{{change.key}}" />
                        <datalist id="predefinedOptions_{{@root.effect.uuid}}">
                            {{#each @root.selectEffectKeys}}
                                {{#unless this.actionOnly}}
                                    <option value="{{this.name}}">
                                {{/unless}}
                            {{/each}}
                        </datalist>
                    </div>

                    {{!-- effect mode/operation --}}
                    <div class="mode">
                        <select name="changes.{{i}}.mode" data-dtype="Number">
                            {{selectOptions ../modes selected=change.mode}}
                        </select>
                    </div>

                    {{!-- effect data - supports codemirror editor --}}
                    <div class="value">                        
                        <div class="cm-toolbar">
                            <button id="format-code">Format Code</button>
                            <button id="close">Close</button>
                        </div>
                        <textarea class="code-editor effect-editor" type="text" name="changes.{{i}}.value">{{change.value}}</textarea>
                    </div>
                    <div class="effect-controls" style="flex: 0 0 40px;">
                        <a class="effect-control" data-action="delete"><i class="fas fa-trash"></i></a>
                        <a class="effect-control cm-launch" title="Launch Code Editor" style="margin-right: 3px;" data-action="edit"><i class="fas fa-edit"></i></a>
                    </div>
                </li>
            {{/each}}
        </ol>
    </section>

    <footer class="sheet-footer">
        <button type="submit"><i class="fas fa-save"></i> {{localize submitText}}</button>
    </footer>
</form>